//
//
// C++ Implementation for module: DubApp
//
// Description: 
//
//
// Author: Eray (exa) Ozkural, (C) 2003
//
// Copyright: See COPYING file that comes with this distribution
//
//

// include files for QT
#include <qdir.h>
#include <qprinter.h>
#include <qpainter.h>

// include files for KDE
#include <kiconloader.h>
#include <kdebug.h>
#include <kfiledialog.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <klocale.h>
#include <kconfig.h>
#include <kstdaction.h>
#include <noatun/playlist.h>

// application specific includes
#include "dubapp.h"
#include "dubapp.moc"
#include "dubview.h"

#define ID_STATUS_MSG 1

DubApp::DubApp(QWidget* parent, const char* name)
  : KMainWindow(parent, name)
{
  kdDebug() << "cons dubapp" << endl;
  config=kapp->config();

  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  initStatusBar();
  initActions();
  initView();
  setAutoSaveSettings();

  readOptions();

  ///////////////////////////////////////////////////////////////////
  // disable actions at startup
  //filePrint->setEnabled(false);

}

DubApp::~DubApp()
{
  kdDebug() << "destruct dubapp" << endl;
}

void DubApp::initActions()
{
  //fileQuit = KStdAction::quit(this, SLOT(slotFileQuit()), actionCollection());
  fileClose = KStdAction::close(this, SLOT(slotFileClose()), actionCollection());
  setStandardToolBarMenuEnabled(true);
  createStandardStatusBarAction();

  //fileQuit->setStatusText(i18n("Quits the application"));
  fileClose->setStatusText(i18n("Close playlist window"));

  // use the absolute path to your dubui.rc file for testing purpose in createGUI();
  createGUI();
}


void DubApp::initStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  // STATUSBAR
  // TODO: add your own items you need for displaying current application status.
  statusBar()->insertItem(i18n("Ready."), ID_STATUS_MSG);
}

void DubApp::initView()
{
  ////////////////////////////////////////////////////////////////////
  // create the main widget here that is managed by KTMainWindow's view-region and
  // connect the widget to your document to display document contents.

  view = new DubView(this);
  setCentralWidget(view);
  setCaption("Dub Playlist",false);
}


void DubApp::saveOptions()
{
}


void DubApp::readOptions()
{
}

void DubApp::saveProperties(KConfig *_cfg)
{
}


void DubApp::readProperties(KConfig* _cfg)
{
}

bool DubApp::queryClose()
{
  return true;
}

bool DubApp::queryExit()
{
  saveOptions();
  return true;
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void DubApp::slotFileClose()
{
}

void DubApp::slotFileQuit()
{
  slotStatusMsg(i18n("Exiting..."));
  saveOptions();
  return;
}

void DubApp::slotStatusMsg(const QString &text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message permanently
  statusBar()->clear();
  statusBar()->changeItem(text, ID_STATUS_MSG);
}
